// for proto type declartion
#include <windows.h>
#define ERRCODE       int
#define DLLCALL         __far __pascal __export

// source type
#define  SRC_TV_TUNER            0
#define  SRC_CCD                                 0
#define  SRC_S_VIDEO             1
#define  SRC_VIDEO               2
#define  SRC_MPEG                3
#define  SRC_VIDEO1              4
#define  SRC_VIDEO2              5
#define  SRC_VIDEO3              6
#define  SRC_VIDEO4              7

// video system
#define  VIDEO_SYSTEM_NTSC       0
#define  VIDEO_SYSTEM_PAL        1
#define  VIDEO_SYSTEM_SECAM      2

// These are defines for TV standard (CCIR) dependent sizes.
#define  NTSC_CCIR_TWIDTH      858
#define  NTSC_CCIR_THEIGHT     525
#define  NTSC_CCIR_WIDTH       720
#define  NTSC_CCIR_HEIGHT      480
#define  NTSC_CCIR_HS          81
#define  NTSC_CCIR_VS          20
#define  PAL_CCIR_TWIDTH       864
#define  PAL_CCIR_THEIGHT      625
#define  PAL_CCIR_WIDTH        720
#define  PAL_CCIR_HEIGHT       576
#define  PAL_CCIR_HS           107
#define  PAL_CCIR_VS           22

// These are defines for TV standard (SQL) dependent sizes.
#define  NTSC_SQL_TWIDTH       780
#define  NTSC_SQL_THEIGHT      525
#define  NTSC_SQL_WIDTH        640
#define  NTSC_SQL_HEIGHT       480
#define  NTSC_SQL_HS           117
#define  NTSC_SQL_VS           20
#define  PAL_SQL_TWIDTH        944
#define  PAL_SQL_THEIGHT       625
#define  PAL_SQL_WIDTH         768
#define  PAL_SQL_HEIGHT        576
#define  PAL_SQL_HS            107
#define  PAL_SQL_VS            22

// video color
#define  VIDEO_BRIGHTNESS        0
#define  VIDEO_SATURATION        1
#define  VIDEO_HUE               2
#define  VIDEO_SHARPNESS         3
#define  VIDEO_CONTRAST          4

// audio system
#define  AUDIO_VOLUME            0
#define  AUDIO_BASS              1
#define  AUDIO_TREBLE            2
#define  AUDIO_L_CHANNEL         3
#define  AUDIO_R_CHANNEL         4
#define  AUDIO_STEREO            5
#define  AUDIO_MUTE              6

// tv tuner system
#define  MAX_TUNER_SYSTEM        2 // air/cable only
#define  TV_AIR                  0
#define  TV_CABLE                1
#define  TV_FAVORITE             2

// cc & teletext
#define  CC_ON                   0
#define  CC_OFF                  1
#define  TELETEXT_ON             2
#define  TELETEXT_OFF            3

//image capture format
#define  CF_RGB555              0
#define  CF_RGB565              1
#define  CF_RGB888              2
#define  CF_RGB888X             3
#define  CF_YUY2                4         //YUV422:YUYV
#define  CF_UYVY                5         //YUV422:UYVY
#define  CF_YVU12               6

//driver error code reported
#define  TEK_OK                 0
#define  TEK_ERR_NOHARDWARE     -1
#define  TEK_ERR_INITHWFAIL     -2
#define  TEK_ERR_NOINIFILE      -3
#define  TEK_ERR_NODMAVXD       -4
#define  TEK_ERR_NODCI          -5
#define  TEK_ERR_DCIPRIMARY     -6
#define  TEK_ERR_DCIMEMORY      -7
#define  TEK_ERR_NOTSUPPORT     -8
#define  TEK_ERR_CAPTURESIZE    -9
#define  TEK_ERR_CAPTUREFAIL    -10

// used by customer app
typedef struct {
LPSTR  lpBmp;       //LPSTR is the buffer to store image data
DWORD  dwBufferSize;    //size of the buffer
DWORD  dwBytesUsed;    //the actural image size
} DSDATA,FAR* LPDATA;


BOOL TEK_DetectHW();
int  DLLCALL TEK_Init();
void DLLCALL TEK_DeInit(int );
BOOL DLLCALL TEK_SetIniFile(int,char far *);
BOOL DLLCALL TEK_GetIniFile(int,char  far *);
void DLLCALL TEK_SaveIniFile(int , char far *);
int  DLLCALL TEK_GetTotalVideoSource(int);
int  DLLCALL TEK_GetIniSourceNum(int);
int  DLLCALL TEK_GetActiveSource(int);
int  DLLCALL TEK_GetSourceInfo(int  , int , char far *);
int  DLLCALL TEK_GetSourceSystem(int  , int );
void DLLCALL TEK_SetSourceSystem(int  , int,int);
void DLLCALL TEK_SetActiveSource(int  , int );
void DLLCALL TEK_SetCurInputViewport(int , LPRECT );
void DLLCALL TEK_GetCurInputViewport(int , LPRECT );
void DLLCALL TEK_SetVideoColor(int , int , int );
void DLLCALL TEK_GetVideoColor(int , int ,int far *,int far *, int far * );
BOOL DLLCALL TEK_SetOutputWindow(int,HWND,int far * ,int far * ,int far *,int far *);
void DLLCALL TEK_GetOutputWindow(int,HWND far *,int far *,int far *,int far *,int far *);
void DLLCALL TEK_SetPanAndScroll(int,LPRECT);

BOOL DLLCALL TEK_Freeze(int);
BOOL DLLCALL TEK_UnFreeze(int);
BOOL DLLCALL TEK_FreezeAndGrabFrame(int,int);
BOOL DLLCALL TEK_GrabFrameToBuff(int,char _huge *,BOOL);
BOOL DLLCALL TEK_GrabFrameToFile(int,char far *);
void DLLCALL TEK_DispErrorMessage(int);
//LOW level functions

int  DLLCALL TEK_GetAvailableBoardID();
BOOL DLLCALL TEK_InitBoard(int);
BOOL DLLCALL TEK_CloseBoard(int);
int  DLLCALL TEK_GetErrorCode(int);

void DLLCALL TEK_GetInputViewport(int,LPRECT);
void DLLCALL TEK_SetInputViewport(int,LPRECT);
void DLLCALL TEK_GetOutputViewport(int,int far *,int far *,int far *,int far *);
void DLLCALL TEK_SetOutputViewport(int,LPRECT);

BOOL DLLCALL TEK_GetVGAMode(int ,int far *);
void DLLCALL TEK_SetCaptureImgType(int,int); //0:rgb555, 1:rgb565,2:rgb888
int  DLLCALL TEK_NumberOfFormat(int );
BOOL DLLCALL TEK_SetFormat(int  ,int ,int );
BOOL DLLCALL TEK_GetFormat(int ,int ,int far *,int far *);
BOOL DLLCALL TEK_CaptureStart(int  ,LPDATA );
BOOL DLLCALL TEK_CaptureFrame(int ,LPDATA );
void DLLCALL TEK_CaptureFinish(int );
void DLLCALL TEK_CaptureSingleFrame(int ,LPDATA );
//ISR capture function
BOOL DLLCALL TEK_CaptureStreamStart(int ,FARPROC ,LPDATA );
void DLLCALL TEK_CaptureStreamStop(int );
void DLLCALL TEK_SupplyStreamGrabBuffer (int, LPDATA);
void DLLCALL TEK_EnableIsr(int);
void DLLCALL TEK_DisableIsr(int);
BOOL DLLCALL TEK_SetPreviewMode(int,BOOL);
BOOL DLLCALL TEK_SetFormatWindow(int,HWND,int far * ,int far * ,int far *,int far *);

BOOL DLLCALL TEK_DetectDMAVxd(void);

void DLLCALL TEK_SetUserMask(int,LPBITMAP,BOOL);

void DLLCALL TEK_StartGrabWithoutStopping(int borad_ID);
LPBYTE DLLCALL TEK_GetGrabBufPointer(int borad_ID);
void DLLCALL TEK_StopGrab(int borad_ID);
BOOL DLLCALL TEK_Load1(int board_ID,char _huge *,int,int);
