// for proto type declartion
#include <windows.h>
#define ERRCODE       int
#define DLLCALL       pascal

// source type
#define  SRC_TV_TUNER            0
#define  SRC_S_VIDEO             1
#define  SRC_VIDEO               2
#define  SRC_MPEG                3
#define  SRC_VIDEO1              4
#define  SRC_VIDEO2              5
#define  SRC_VIDEO3              6
#define  SRC_VIDEO4              7

// video system
#define  VIDEO_SYSTEM_NTSC       0
#define  VIDEO_SYSTEM_PAL        1
#define  VIDEO_SYSTEM_SECAM      2

// video color
#define  VIDEO_BRIGHTNESS        0
#define  VIDEO_SATURATION        1
#define  VIDEO_HUE               2
#define  VIDEO_SHARPNESS         3
#define  VIDEO_CONTRAST          4

// audio system
#define  AUDIO_VOLUME            0
#define  AUDIO_BASS              1
#define  AUDIO_TREBLE            2
#define  AUDIO_L_CHANNEL         3
#define  AUDIO_R_CHANNEL         4
#define  AUDIO_STEREO            5
#define  AUDIO_MUTE              6

// tv tuner system
#define  MAX_TUNER_SYSTEM        2 // air/cable only
#define  TV_AIR                  0
#define  TV_CABLE                1
#define  TV_FAVORITE             2

// cc & teletext
#define  CC_ON                   0
#define  CC_OFF                  1
#define  TELETEXT_ON             2
#define  TELETEXT_OFF            3

//image capture format
#define  CF_RGB555              0
#define  CF_RGB565              1
#define  CF_RGB888              2
#define  CF_RGB888X             3
#define  CF_YUY2                4
#define  CF_UYVY                5
#define  CF_YVU12               6
// used by customer app
typedef struct {
LPSTR  lpBmp;       //LPSTR is the buffer to store image data
DWORD  dwBufferSize;    //size of the buffer
DWORD  dwBytesUsed;    //the actural image size
} DSDATA,FAR* LPDATA;

BOOL TEK_DetectHW();
int  DLLCALL TEK_Init_32();
void DLLCALL TEK_DeInit_32(int );
BOOL DLLCALL TEK_SetIniFile_32(int,char far *);
BOOL DLLCALL TEK_GetIniFile_32(int,char  far *);
void DLLCALL TEK_SaveIniFile_32(int , char far *);
int  DLLCALL TEK_GetTotalVideoSource_32(int);
int  DLLCALL TEK_GetIniSourceNum_32(int);
int  DLLCALL TEK_GetActiveSource_32(int);
int  DLLCALL TEK_GetSourceInfo_32(int  , int , char far *);
int  DLLCALL TEK_GetSourceSystem_32(int  , int );
void DLLCALL TEK_SetSourceSystem_32(int  , int,int);
void DLLCALL TEK_SetActiveSource_32(int  , int );
void DLLCALL TEK_SetCurInputViewport_32(int , LPRECT );
void DLLCALL TEK_GetCurInputViewport_32(int , LPRECT );
void DLLCALL TEK_SetVideoColor_32(int , int , int );
void DLLCALL TEK_GetVideoColor_32(int , int ,int far *,int far *, int far * );
BOOL DLLCALL TEK_SetOutputWindow_32(int,HWND,int far * ,int far * ,int far *,int far *);
void DLLCALL TEK_GetOutputWindow_32(int,HWND far *,int far *,int far *,int far *,int far *);
void DLLCALL TEK_SetPanAndScroll_32(int,LPRECT);

BOOL DLLCALL TEK_Freeze_32(int);
BOOL DLLCALL TEK_UnFreeze_32(int);
BOOL DLLCALL TEK_FreezeAndGrabFrame_32(int,int imgFmt);
BOOL DLLCALL TEK_GrabFrameToBuff_32(int,char far *,BOOL);
BOOL DLLCALL TEK_GrabFrameToFile_32(int,char far *);

//LOW level functions

int  DLLCALL TEK_GetAvailableBoardID_32();
BOOL DLLCALL TEK_InitBoard_32(int);
BOOL DLLCALL TEK_CloseBoard_32(int);

void DLLCALL TEK_GetInputViewport_32(int,LPRECT);
void DLLCALL TEK_SetInputViewport_32(int,LPRECT);
void DLLCALL TEK_GetOutputViewport_32(int,int far *,int far *,int far *,int far *);
void DLLCALL TEK_SetOutputViewport_32(int,LPRECT);

BOOL DLLCALL TEK_GetVGAMode_32(int ,int far *);
void DLLCALL TEK_SetCaptureImgType_32(int,int); //0:rgb555, 1:rgb565,2:rgb888
BOOL DLLCALL TEK_SetFormat_32(int  ,int ,int );
//BOOL DLLCALL TEK_GetFormat_32(int ,int ,int far *,int far *);
BOOL DLLCALL TEK_CaptureStart_32(int  ,LPDATA );
void DLLCALL TEK_CaptureSingleFrame_32(int ,LPDATA );
BOOL DLLCALL TEK_CaptureFrame_32(int ,LPDATA );
void DLLCALL TEK_CaptureFinish_32(int );

BOOL DLLCALL TEK_SetPreviewMode_32(int,BOOL);
BOOL DLLCALL TEK_SetFormatWindow_32(int,HWND,int far * ,int far * ,int far *,int far *);

//void DLLCALL TEK_StartGrabWithoutStopping_32(int borad_ID);
//LPBYTE DLLCALL TEK_GetGrabBufPointer_32(int borad_ID);
//void DLLCALL TEK_StopGrab_32(int borad_ID);
