
/****************************************************************************

        PROGRAM: TV.C

        PURPOSE: TV Tuner application sample program

****************************************************************************/

#include <windows.h>   // required for all Windows applications
#include "resource.h"  // Windows resource IDs
#include "tv.h"        // specific to this program
#include "dll32.h"

#define SOURCE_VIDEO1   0
#define SOURCE_VIDEO2   1
#define SOURCE_SVIDEO   2
#define HCROP                   1111
#define VCROP                   2222

#define TV_WIDTH        320
#define TV_HEIGHT       240

HINSTANCE hInst;        // current instance

char szAppName[] = "Tekram TV Tuner";
char szTitle[]   = "TEKRAM TV Tuner Sample Application";

int      board_id,VIDEO_ID;                      // TV Tuner board id
int  min_val, max_val, cur_val,set_color;
char   txtbuf[40];
RECT    Vrc,Temprc;
/* TV Tuner system function entries */
int (FAR PASCAL *gpfnTEK_Init)() = NULL;
void (FAR PASCAL *gpfnTEK_DeInit)(int) = NULL;
int  (FAR PASCAL *gpfnTEK_GetActiveSource)(int) = NULL;
int  (FAR PASCAL *gpfnTEK_GetSourceInfo)(int, int, char far *) = NULL;
int  (FAR PASCAL *gpfnTEK_GetSourceSystem)(int, int) = NULL;
void (FAR PASCAL *gpfnTEK_SetSourceSystem)(int, int, int) = NULL;
BOOL (FAR PASCAL *gpfnTEK_SetActiveSource)(int, int) = NULL;
BOOL (FAR PASCAL *gpfnTEK_SetVideoColor)(int, int, int) = NULL;
BOOL (FAR PASCAL *gpfnTEK_GetVideoColor)(int, int, int far *, int far *, int far *) = NULL;
BOOL (FAR PASCAL *gpfnTEK_SetOutputWindow)(int, HWND, int far *, int far *, int far*, int far *) = NULL;
BOOL (FAR PASCAL *gpfnTEK_Freeze)(int) = NULL;
BOOL (FAR PASCAL *gpfnTEK_UnFreeze)(int) = NULL;
BOOL (FAR PASCAL *gpfnTEK_SetCaptureImgType)(int, int) = NULL;
BOOL (FAR PASCAL *gpfnTEK_SetFormat)(int, int, int ) = NULL;
void (FAR PASCAL *gpfnTEK_CaptureSingleFrame)(int, LPDATA) = NULL;
BOOL (FAR PASCAL *gpfnTEK_SetPreviewMode)(int, BOOL ) = NULL;
BOOL (FAR PASCAL *gpfnTEK_FreezeAndGrabFrame)(int, int ) = NULL;
BOOL (FAR PASCAL *gpfnTEK_GrabFrameToBuff)(int, char far *,BOOL ) = NULL;
BOOL (FAR PASCAL *gpfnTEK_GrabFrameToFile)(int, char far * ) = NULL;
void (FAR PASCAL *gpfnTEK_CaptureStart)(int, LPDATA) = NULL;
BOOL (FAR PASCAL *gpfnTEK_CaptureFrame)(int, LPDATA) = NULL;
void (FAR PASCAL *gpfnTEK_CaptureFinish)(int) = NULL;
void (FAR PASCAL *gpfnTEK_GetCurInputViewport)(int,LPRECT) = NULL;
void (FAR PASCAL *gpfnTEK_SetCurInputViewport)(int,LPRECT) = NULL;
int dd1(WPARAM wParam, LPARAM lParam, int nMax, int nMin, int nValue);
int dd(WPARAM wParam, LPARAM lParam, int nMax, int nMin, int nValue);
HWND  hTek;

/**************************************************************************

        FUNCTION: WinMain(HINSTANCE, HINSTANCE, LPSTR, int)

        PURPOSE: calls initialization function, processes message loop

****************************************************************************/
int CALLBACK WinMain(
        HINSTANCE hInstance,
        HINSTANCE hPrevInstance,
        LPSTR lpCmdLine,
        int nCmdShow)
{

        MSG msg;

        if (!hPrevInstance) {       // Other instances of app running?
                        if (!InitApplication(hInstance)) { // Initialize shared things
                        return (FALSE);     // Exits if unable to initialize
                }
        }

        /* Perform initializations that apply to a specific instance */

        if (!InitInstance(hInstance, nCmdShow)) {
                return (FALSE);
        }

        /* Acquire and dispatch messages until a WM_QUIT message is received. */

        while (GetMessage(&msg, // message structure
           NULL,   // handle of window receiving the message
           0,      // lowest message to examine
           0))     // highest message to examine
        {
            TranslateMessage(&msg);// Translates virtual key codes
            DispatchMessage(&msg); // Dispatches message to window
        }


        return (msg.wParam); // Returns the value from PostQuitMessage

        lpCmdLine; // This will prevent 'unused formal parameter' warnings
}


/****************************************************************************

        FUNCTION: InitApplication(HINSTANCE)

        PURPOSE: Initializes window data and registers window class

****************************************************************************/

BOOL InitApplication(HINSTANCE hInstance)
{
        WNDCLASS  wc;

        // Fill in window class structure with parameters that describe the
        // main window.

        wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;// Class style(s).
        wc.lpfnWndProc   = (WNDPROC)WndProc;       // Window Procedure
        wc.cbClsExtra    = 0;                      // No per-class extra data.
        wc.cbWndExtra    = 0;                      // No per-window extra data.
        wc.hInstance     = hInstance;              // Owner of this class
        wc.hIcon         = NULL;
        wc.hCursor       = LoadCursor(NULL, IDC_ARROW);// Cursor
        wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);// Default color
        wc.lpszMenuName  = MAKEINTRESOURCE(IDR_TV); // Menu from .RC
        wc.lpszClassName = szAppName;              // Name to register as

        // Register the window class and return success/failure code.
        return (RegisterClass(&wc));
}


/****************************************************************************

        FUNCTION:  InitInstance(HINSTANCE, int)

        PURPOSE:  Saves instance handle and creates main window

****************************************************************************/

BOOL InitInstance(
        HINSTANCE          hInstance,
        int             nCmdShow)
{
        HWND            hWnd; // Main window handle.

        // Save the instance handle in static variable, which will be used in
        // many subsequence calls from this application to Windows.

        hInst = hInstance; // Store instance handle in our global variable

        // Create a main window for this application instance.

        hWnd = CreateWindow(
                szAppName,           // See RegisterClass() call.
                szTitle,             // Text for window title bar.
                WS_OVERLAPPED,       // Window style.
                128, 64, TV_WIDTH, TV_HEIGHT,
                NULL,                // Overlapped windows have no parent.
                NULL,                // Use the window class menu.
                hInstance,           // This instance owns this window.
                NULL                 // We don't use any data in our WM_CREATE
        );

        // If window could not be created, return "failure"
        if (!hWnd) {
                return (FALSE);
        }


        // Make the window visible; update its client area; and return "success"
        ShowWindow(hWnd, nCmdShow); // Show the window
        UpdateWindow(hWnd);         // Sends WM_PAINT message

        PostMessage(hWnd, WM_COMMAND, (WPARAM)IDM_ABOUT, 0);

        return (TRUE);              // We succeeded...

}

/****************************************************************************

        FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)

        PURPOSE:  Processes messages

        MESSAGES:

        WM_COMMAND    - application menu (About dialog box)
        WM_DESTROY    - destroy window

****************************************************************************/

LRESULT CALLBACK WndProc(
                HWND hWnd,         // window handle
                UINT message,      // type of message
                WPARAM uParam,     // additional information
                LPARAM lParam)     // additional information
{
        FARPROC lpProcDlg;
        FARPROC lpProcAbout;
        static HMENU  hSubMenu, hSubMenu1;
        static unsigned int old_source,old_format;

                int     nWidth, nHeight, nLeft, nTop;
                RECT ClientRect;
                POINT pt;
                DWORD  size;
                static  HGLOBAL hGlob=0;
                LPSTR  lpBufPtr;
                static int Cur_Width,Cur_Height,Cur_Format;
                DSDATA  AppData;
                int     count;
        switch (message) {

                case WM_COMMAND:  // message: command from application menu

                        switch (uParam) {
                                case IDM_ABOUT:
                                        lpProcAbout = MakeProcInstance((FARPROC)About, hInst);

                                        DialogBox(hInst,           // current instance
                                                MAKEINTRESOURCE(IDD_ABOUTBOX), // dlg resource to use
                                                hWnd,                  // parent handle
                                                (DLGPROC)lpProcAbout); // About() instance address

                                        FreeProcInstance(lpProcAbout);
                                        break;

                                case IDM_EXIT:
                                        DestroyWindow (hWnd);
                                        break;

                                case ID_CONTROL_SOURCE_VIDEO1:
                                        (*gpfnTEK_SetActiveSource)(board_id, SOURCE_VIDEO1);
                                        CheckMenuItem (hSubMenu1, old_source, MF_UNCHECKED | MF_BYCOMMAND);
                                        CheckMenuItem (hSubMenu1, old_source=uParam, MF_CHECKED | MF_BYCOMMAND);
                                        break;
                                case ID_CONTROL_SOURCE_VIDEO2:
                                        (*gpfnTEK_SetActiveSource)(board_id, SOURCE_VIDEO2);
                                        CheckMenuItem (hSubMenu1, old_source, MF_UNCHECKED | MF_BYCOMMAND);
                                        CheckMenuItem (hSubMenu1, old_source=uParam, MF_CHECKED | MF_BYCOMMAND);
                                        break;
                                case ID_CONTROL_SOURCE_SVIDEO:
                                        (*gpfnTEK_SetActiveSource)(board_id, SOURCE_SVIDEO);
                                        CheckMenuItem (hSubMenu1, old_source, MF_UNCHECKED | MF_BYCOMMAND);
                                        CheckMenuItem (hSubMenu1, old_source=uParam, MF_CHECKED | MF_BYCOMMAND);
                                        break;

                                case ID_OPTIONS_BRIGHTNESS:
                                                                        set_color=VIDEO_BRIGHTNESS;
                                                                        strcpy(txtbuf,"Current Brightness Value:\0");
                                                                        (*gpfnTEK_GetVideoColor)(board_id, VIDEO_BRIGHTNESS, &cur_val, &max_val, &min_val);
                                        lpProcDlg = MakeProcInstance((FARPROC)InputBrightness, hInst);
                                        DialogBox(hInst,
                                                MAKEINTRESOURCE(IDD_DISPLAY),
                                                hWnd,
                                                (DLGPROC)lpProcDlg);

                                        FreeProcInstance(lpProcDlg);
                                    break;
                                case ID_OPTIONS_CONTRAST:
                                        set_color=VIDEO_CONTRAST;
                                        strcpy(txtbuf,"Current Contrast Value:\0");
                                                                        (*gpfnTEK_GetVideoColor)(board_id, VIDEO_CONTRAST, &cur_val, &max_val, &min_val);
                                        lpProcDlg = MakeProcInstance((FARPROC)InputBrightness, hInst);
                                        DialogBox(hInst,
                                                MAKEINTRESOURCE(IDD_DISPLAY),
                                                hWnd,
                                                (DLGPROC)lpProcDlg);

                                        FreeProcInstance(lpProcDlg);
                                    break;
                                case ID_OPTIONS_SHARPNESS:
                                                                        set_color=VIDEO_SHARPNESS;
                                                                        strcpy(txtbuf,"Current Sharpness Value:\0");
                                                                        (*gpfnTEK_GetVideoColor)(board_id, VIDEO_SHARPNESS, &cur_val, &max_val, &min_val);
                                                             lpProcDlg = MakeProcInstance((FARPROC)InputBrightness, hInst);
                                        DialogBox(hInst,
                                                MAKEINTRESOURCE(IDD_DISPLAY),
                                                hWnd,
                                                (DLGPROC)lpProcDlg);

                                        FreeProcInstance(lpProcDlg);
                                    break;
                                case ID_OPTIONS_HUE:
                                        set_color=VIDEO_HUE;
                                        strcpy(txtbuf,"Current Hue Value:\0");
                                                                        (*gpfnTEK_GetVideoColor)(board_id, VIDEO_HUE, &cur_val, &max_val, &min_val);
                                        lpProcDlg = MakeProcInstance((FARPROC)InputBrightness, hInst);
                                        DialogBox(hInst,
                                                MAKEINTRESOURCE(IDD_DISPLAY),
                                                hWnd,
                                                (DLGPROC)lpProcDlg);

                                        FreeProcInstance(lpProcDlg);
                                    break;
                                 case ID_OPTIONS_SATURATION:
                                                                        set_color=VIDEO_SATURATION;
                                                                        strcpy(txtbuf,"Current Saturation Value:\0");
                                                                        (*gpfnTEK_GetVideoColor)(board_id, VIDEO_SATURATION, &cur_val, &max_val, &min_val);
                                                                                                            lpProcDlg = MakeProcInstance((FARPROC)InputBrightness, hInst);

                                        DialogBox(hInst,
                                                MAKEINTRESOURCE(IDD_DISPLAY),
                                                hWnd,
                                                (DLGPROC)lpProcDlg);

                                        FreeProcInstance(lpProcDlg);
                                        break;

                                  case ID_HCROP:
                                        set_color=HCROP;
                                                                        strcpy(txtbuf,"Current HCroping Value:\0");
                                                                           (*gpfnTEK_GetCurInputViewport)(board_id, &Vrc);
                                        CopyRect(&Temprc,&Vrc);
                                        min_val=0;
                                        max_val=780-640;  //assume NTSC
                                        cur_val=Vrc.left;
                                        lpProcDlg = MakeProcInstance((FARPROC)InputBrightness, hInst);

                                        DialogBox(hInst,
                                                MAKEINTRESOURCE(IDD_DISPLAY),
                                                hWnd,
                                                (DLGPROC)lpProcDlg);

                                        FreeProcInstance(lpProcDlg);
                                        break;
                                  case ID_VCROP:
                                        set_color=VCROP;
                                                                        strcpy(txtbuf,"Current VCroping Value:\0");
                                                                          (*gpfnTEK_GetCurInputViewport)(board_id, &Vrc);
                                                                           CopyRect(&Temprc,&Vrc);
                                                                           min_val=0;
                                                                           max_val=525-480; //assume NTSC
                                                                           cur_val=Vrc.top;
                                       lpProcDlg = MakeProcInstance((FARPROC)InputBrightness, hInst);

                                        DialogBox(hInst,
                                                MAKEINTRESOURCE(IDD_DISPLAY),
                                                hWnd,
                                                (DLGPROC)lpProcDlg);

                                        FreeProcInstance(lpProcDlg);
                                        break;

                                                                case ID_RGB555:
                                                                                Cur_Width=320L;
                                                                                Cur_Height=240L;
                                                                                Cur_Format=CF_RGB555;
                                                                                CheckMenuItem (hSubMenu1, old_format, MF_UNCHECKED | MF_BYCOMMAND);
                                                                                CheckMenuItem (hSubMenu1, old_format=uParam, MF_CHECKED | MF_BYCOMMAND);
                                                                                (*gpfnTEK_Freeze)(board_id);   //stop video DMA transfer
                                                                                (*gpfnTEK_SetCaptureImgType)(board_id, CF_RGB555);  //set capture image pixel format
                                                                                (*gpfnTEK_SetFormat)(board_id, 320,240);   //set capture size dx*dy
                                                                                (*gpfnTEK_UnFreeze)(board_id);  //start video DMA transfer
                                                                                break;
                                                                case ID_RGB888:
                                                                                Cur_Width=320L;
                                                                                Cur_Height=240L;
                                                                                Cur_Format=CF_RGB888;
                                                                                CheckMenuItem (hSubMenu1, old_format, MF_UNCHECKED | MF_BYCOMMAND);
                                                                                CheckMenuItem (hSubMenu1, old_format=uParam, MF_CHECKED | MF_BYCOMMAND);
                                                                                    (*gpfnTEK_Freeze)(board_id);
                                                                                    (*gpfnTEK_SetCaptureImgType)(board_id, CF_RGB888);
                                                                                (*gpfnTEK_SetFormat)(board_id, 320,240);
                                                                                (*gpfnTEK_UnFreeze)(board_id);
                                                                                break;
                                                                case ID_YUV422:
                                                                                Cur_Width=320L;
                                                                                Cur_Height=240L;
                                                                                Cur_Format=CF_UYVY;
                                                                                CheckMenuItem (hSubMenu1, old_format, MF_UNCHECKED | MF_BYCOMMAND);
                                                                                CheckMenuItem (hSubMenu1, old_format=uParam, MF_CHECKED | MF_BYCOMMAND);
                                                                                (*gpfnTEK_Freeze)(board_id);
                                                                                (*gpfnTEK_SetCaptureImgType)(board_id, CF_UYVY);
                                                                                (*gpfnTEK_SetFormat)(board_id, 320,240);
                                                                                (*gpfnTEK_UnFreeze)(board_id);
                                                                                break;


                                                                case ID_TOBUFFER:

                                                                                size=(DWORD)(Cur_Width)*(DWORD)(Cur_Height);
                                                                                if (Cur_Format==CF_RGB888)
                                                                                        size=size*3;
                                                                                else size=size*2;
                                                                                if (hGlob) {
                                                                                        GlobalUnlock(hGlob);
                                                                                        GlobalFree(hGlob);
                                                                                }

                                                                                hGlob=GlobalAlloc(GMEM_ZEROINIT | GMEM_MOVEABLE,size);
                                                                                if (hGlob)
                                                                                        lpBufPtr=(LPBYTE)GlobalLock(hGlob);

                                                                                //you can use #1 or #2 to capture to buffer
                                                                                //#1
                                                                                //if ((*gpfnTEK_FreezeAndGrabFrame)(board_id,Cur_Format))
                                                                                // choose one of them
                                                                                //(*gpfnTEK_GrabFrameToBuff)(board_id,(char *)lpBufPtr,0);  //bottom to up
                                                                                //(*gpfnTEK_GrabFrameToBuff)(board_id,(char *)lpBufPtr,1);  //top to down
                                                                                // start video display
                                                                                //(*gpfnTEK_UnFreeze)(board_id);
                                                                                //#2
                                                                                (*gpfnTEK_SetCaptureImgType)(board_id, Cur_Format);
                                                                                (*gpfnTEK_SetFormat)(board_id, Cur_Width,Cur_Height);
                                                                                AppData.lpBmp=lpBufPtr;
                                                                                AppData.dwBufferSize=size;
                                                                                (*gpfnTEK_CaptureSingleFrame)(board_id,&AppData);
                                                                                break;
                                                                case ID_TOFILE:
                                                                                //it can be save as bmp file only. CF_UYVY can not be used
                                                                                (*gpfnTEK_FreezeAndGrabFrame)(board_id,Cur_Format);
                                                                                (*gpfnTEK_GrabFrameToFile)(board_id,"c:\\test.bmp");
                                                                                (*gpfnTEK_UnFreeze)(board_id);
                                                                                break;
                                                                case ID_CONTINUE:
                                                                                size=(DWORD)(Cur_Width)*(DWORD)(Cur_Height);
                                                                                if (Cur_Format==CF_RGB888)
                                                                                        size=size*3;
                                                                                else size=size*2;
                                                                                if (hGlob) {
                                                                                        GlobalUnlock(hGlob);
                                                                                        GlobalFree(hGlob);
                                                                                }

                                                                                hGlob=GlobalAlloc(GPTR,size);
                                                                                if (hGlob)
                                                                                        lpBufPtr=GlobalLock(hGlob);
                                default:                                        (*gpfnTEK_SetCaptureImgType)(board_id, Cur_Format);
                                                                                (*gpfnTEK_SetFormat)(board_id, Cur_Width,Cur_Height);
                                                                                AppData.lpBmp=lpBufPtr;
                                                                                AppData.dwBufferSize=size;
                                                                                //continue capture 100 frames
                                                                                (*gpfnTEK_CaptureStart)(board_id,&AppData);
                                                                                count=0;
                                                                                while (count <100) {

                                                                                if ((*gpfnTEK_CaptureFrame)(board_id,&AppData)) {
                                                                                    count=count+1;
                                                                                    // move data to somewhere or do something here
                                                                                    //  :
                                                                                    //  :
                                                                                    }
                                                                                else
                                                                                    //wait 10ms
                                                                                    //:
                                                                                    ;
                                                                                }
                                                                                 (*gpfnTEK_CaptureFinish)(board_id);
                                                                                 break;
                                        return (DefWindowProc(hWnd, message, uParam, lParam));
                        }
                        break;

                                case WM_MOVE:

                                                                        GetClientRect(hWnd, &ClientRect);
                                                        nWidth  = ClientRect.right-ClientRect.left;
                                                        nHeight = ClientRect.bottom-ClientRect.top;

                                                      nLeft = ClientRect.left;
                                                      nTop  = ClientRect.top;
                                                        pt.x = ClientRect.left;
                                                        pt.y =  ClientRect.top;

                                                      ClientToScreen(hWnd, &pt);
                                                        // set output windows size to show the TV screen
                                                        (*gpfnTEK_SetOutputWindow)(board_id, hWnd, &pt.x, &pt.y, &nWidth, &nHeight);
                                                break;

                case WM_CREATE:  // message: window being destroyed
                                {
                                  HMENU hMenu = GetMenu (hWnd);

                                  hSubMenu  = GetSubMenu (hMenu, 2);
                                  hSubMenu1 = GetSubMenu (hMenu, 1);
#if 1
                                  if (!hTek)
                                  {
                                        if ((hTek = LoadLibrary ("TEKDCI32.DLL"))==NULL)
                                         {
                                                //                                        err=GetLastError();
                                                MessageBox (hWnd,
                                                        (LPSTR) "MainWndProc(): LoadLibrary ('tekdci32.DLL') failed",
                                                        (LPSTR) "Err! - TV",
                                                        MB_OK | MB_ICONEXCLAMATION);
                                        }
                                        else
                                        {

                                            (FARPROC) gpfnTEK_Init = GetProcAddress (hTek,
                                                          "TEK_Init_32");
                                            (FARPROC) gpfnTEK_DeInit = GetProcAddress (hTek,
                                                          "TEK_DeInit_32");
                                            (FARPROC) gpfnTEK_GetActiveSource = GetProcAddress (hTek,
                                                          "TEK_GetActiveSource_32");
                                            (FARPROC) gpfnTEK_GetSourceInfo = GetProcAddress (hTek,
                                                          "TEK_GetSourceInfo_32");
                                            (FARPROC) gpfnTEK_GetSourceSystem = GetProcAddress (hTek,
                                                          "TEK_GetSourceSystem_32");
                                            (FARPROC) gpfnTEK_SetSourceSystem = GetProcAddress (hTek,
                                                          "TEK_SetSourceSystem_32");
                                            (FARPROC) gpfnTEK_SetActiveSource = GetProcAddress (hTek,
                                                          "TEK_SetActiveSource_32");
                                            (FARPROC) gpfnTEK_SetVideoColor = GetProcAddress (hTek,
                                                          "TEK_SetVideoColor_32");
                                            (FARPROC) gpfnTEK_GetVideoColor = GetProcAddress (hTek,
                                                          "TEK_GetVideoColor_32");
                                            (FARPROC) gpfnTEK_SetOutputWindow = GetProcAddress (hTek,
                                                          "TEK_SetOutputWindow_32");
                                            (FARPROC) gpfnTEK_Freeze = GetProcAddress (hTek,
                                                         "TEK_Freeze_32");
                                            (FARPROC) gpfnTEK_UnFreeze = GetProcAddress (hTek,
                                                          "TEK_UnFreeze_32");
                                            (FARPROC) gpfnTEK_SetCaptureImgType = GetProcAddress (hTek,
                                                          "TEK_SetCaptureImgType_32");
                                            (FARPROC) gpfnTEK_SetFormat = GetProcAddress (hTek,
                                                          "TEK_SetFormat_32");
                                            (FARPROC) gpfnTEK_SetPreviewMode = GetProcAddress (hTek,
                                                          "TEK_SetPreviewMode_32");
                                            (FARPROC) gpfnTEK_FreezeAndGrabFrame = GetProcAddress (hTek,
                                                          "TEK_FreezeAndGrabFrame_32");
                                            (FARPROC) gpfnTEK_GrabFrameToBuff = GetProcAddress (hTek,
                                                          "TEK_GrabFrameToBuff_32");
                                            (FARPROC) gpfnTEK_GrabFrameToFile = GetProcAddress (hTek,
                                                          "TEK_GrabFrameToFile_32");
                                            (FARPROC) gpfnTEK_CaptureSingleFrame = GetProcAddress (hTek,
                                                          "TEK_CaptureSingleFrame_32");
                                                                                        (FARPROC) gpfnTEK_CaptureStart = GetProcAddress (hTek,
                                                          "TEK_CaptureStart_32");
                                            (FARPROC) gpfnTEK_CaptureFrame = GetProcAddress (hTek,
                                                          "TEK_CaptureFrame_32");
                                            (FARPROC) gpfnTEK_CaptureFinish = GetProcAddress (hTek,
                                                          "TEK_CaptureFinish_32");
                                             (FARPROC) gpfnTEK_GetCurInputViewport = GetProcAddress (hTek,
                                                          "TEK_GetCurInputViewport_32");
                                             (FARPROC) gpfnTEK_SetCurInputViewport = GetProcAddress (hTek,
                                                          "TEK_SetCurInputViewport_32");
                                             board_id = (*gpfnTEK_Init)();
                                            //(*gpfnTEK_GetVideoColor)(board_id, VIDEO_BRIGHTNESS, &cur_val, &max_val, &min_val);
                                        }
                                        old_source = (*gpfnTEK_GetActiveSource)(board_id);
                                        switch (old_source) {
                                        case 0:
                                        old_source =ID_CONTROL_SOURCE_VIDEO1;
                                        break;
                                        case 1:
                                        old_source =ID_CONTROL_SOURCE_VIDEO2;
                                        break;
                                        case 2:
                                        old_source =ID_CONTROL_SOURCE_SVIDEO;
                                        break;
                                        }
                                        CheckMenuItem (hSubMenu1, old_source, MF_CHECKED | MF_BYCOMMAND);
                                        Cur_Width=320L;
                                        Cur_Height=240L;
                                        Cur_Format=CF_RGB888;
                                        old_format=ID_RGB888;
                                        CheckMenuItem (hSubMenu1, old_format, MF_CHECKED | MF_BYCOMMAND);
                                        (*gpfnTEK_SetCaptureImgType)(board_id, CF_RGB888);
                                        (*gpfnTEK_SetFormat)(board_id, 320,240);

                                                                  }
#endif
                                                                }

                                 break;

                case WM_DESTROY:  // message: window being destroyed
                                                // Close TV Tuner system
                                        if (hTek)
                                        {
                                            (*gpfnTEK_DeInit)(board_id);
                                                FreeLibrary (hTek);
                                        }

                                        if (hGlob) {
                                             GlobalUnlock(hGlob);
                                             GlobalFree(hGlob);
                                        }
                        PostQuitMessage(0);
                        break;

                default:          // Passes it on if unproccessed
                        return (DefWindowProc(hWnd, message, uParam, lParam));
        }
        return (0);
}

/****************************************************************************

        FUNCTION: About(HWND, UINT, WPARAM, LPARAM)

        PURPOSE:  Processes messages for "About" dialog box

        MESSAGES:

        WM_INITDIALOG - initialize dialog box
        WM_COMMAND    - Input received

****************************************************************************/

LRESULT CALLBACK About(
                HWND hDlg,           // window handle of the dialog box
                UINT message,        // type of message
                WPARAM uParam,       // message-specific information
                LPARAM lParam)
{

        switch (message) {
                case WM_INITDIALOG:  // message: initialize dialog box
                        return (TRUE);

                case WM_COMMAND:                      // message: received a command
                        if (LOWORD(uParam) == IDOK        // "OK" box selected?
                        || LOWORD(uParam) == IDCANCEL) {  // System menu close command?
                                EndDialog(hDlg, TRUE);        // Exit the dialog
                                return (TRUE);
                        }
                        break;
        }
        return (FALSE); // Didn't process the message

}

LRESULT CALLBACK InputBrightness(
                HWND hDlg,           // window handle of the dialog box
                UINT message,        // type of message
                WPARAM uParam,       // message-specific information
                LPARAM lParam)
{
        static int temp;
        static int nValue;

        switch (message) {
                case WM_INITDIALOG:  // message: initialize dialog box
                        SetDlgItemText(hDlg, IDC_ColorID, txtbuf);
                        SetScrollRange(GetDlgItem(hDlg, IDC_BRIGHTNESS_SCROLLBAR), SB_CTL, min_val, max_val, TRUE);
                        SetScrollPos(GetDlgItem(hDlg, IDC_BRIGHTNESS_SCROLLBAR), SB_CTL, temp=cur_val, TRUE);
                        SetDlgItemInt(hDlg, IDC_VALUE, cur_val, FALSE);
                        SetDlgItemInt(hDlg, IDC_MAX,   max_val, FALSE);
                        SetDlgItemInt(hDlg, IDC_MIN,   min_val, FALSE);

                        return TRUE;

                case WM_HSCROLL:
                if ((set_color==HCROP)||(set_color==VCROP))
                {
                   nValue = dd(uParam, lParam, max_val, min_val, cur_val);
                   if (nValue==0x7fff) break;
                   cur_val = nValue;
                   SetDlgItemInt(hDlg,IDC_VALUE,cur_val,TRUE);
                   SetScrollPos(GetDlgItem(hDlg, IDC_BRIGHTNESS_SCROLLBAR), SB_CTL, cur_val, TRUE);

                   if (set_color==HCROP) {
                   Vrc.right=Vrc.right-Vrc.left+cur_val;
                   Vrc.left=cur_val;
                   }
                   else {
                   Vrc.bottom=Vrc.bottom-Vrc.top+cur_val;
                   Vrc.top=cur_val;
                   }

                (*gpfnTEK_SetCurInputViewport)(board_id, &Vrc);
                }
                else {
                     nValue = dd1(uParam, lParam, max_val, min_val, cur_val);
                     if (nValue == 0x7fff) break;
                     cur_val=nValue;
                     SetDlgItemInt(hDlg,IDC_VALUE,cur_val,TRUE);
                     SetScrollPos(GetDlgItem(hDlg, IDC_BRIGHTNESS_SCROLLBAR), SB_CTL, cur_val, TRUE);
                     (*gpfnTEK_SetVideoColor)(board_id, set_color, cur_val);
                }
                break;

                case WM_COMMAND:                      // message: received a command
                if (LOWORD(uParam) == IDOK) { // "OK" box selected?
                        //cur_val=nValue;

                        if ((set_color==HCROP)||(set_color==VCROP))
                            (*gpfnTEK_SetCurInputViewport)(board_id, &Vrc);
                        else
                        (*gpfnTEK_SetVideoColor)(board_id, set_color, cur_val);
                        EndDialog(hDlg, TRUE);        // Exit the dialog
                        return (TRUE);
                }
                else if (LOWORD(uParam) == IDCANCEL) {  // System menu close command?
                        EndDialog(hDlg, TRUE);        // Exit the dialog
                        if ((set_color==HCROP)||(set_color==VCROP))
                         (*gpfnTEK_SetCurInputViewport)(board_id, &Temprc);
                        else {
                        cur_val = temp;
                        (*gpfnTEK_SetVideoColor)(board_id, set_color, cur_val);
                        }
                        return (TRUE);
                }
                break;
        }
        return (FALSE); // Didn't process the message

}

int dd(WPARAM wParam, LPARAM lParam, int nMax, int nMin, int nValue)
{
    switch (wParam)
    {
    case SB_LINELEFT:
        if (nValue > nMin)
            return nValue - 2;
        else return nMin;
    case SB_LINERIGHT:
        if (nValue < nMax)
            return nValue + 2;
        else return nMax;
    case SB_PAGELEFT:
        if (nValue > nMin)
            return nValue - 4;

    case SB_PAGERIGHT:
        if (nValue < nMax)
            return nValue + 4;

    case SB_LEFT:
        return nMin;

    case SB_RIGHT:
        return nMax;

    case SB_THUMBPOSITION:
    case SB_THUMBTRACK:
        return (LOWORD(lParam) + (nValue - LOWORD(lParam))%2);
    }

    return 0x7fff;
}

int dd1(WPARAM wParam, LPARAM lParam, int nMax, int nMin, int nValue)
{
    switch (wParam)
    {
    case SB_LINELEFT:
        if (nValue >(signed int)nMin)
            return nValue - 1;
        else return nMin;
    case SB_LINERIGHT:
        if (nValue < (signed int)nMax)
            return nValue + 1;
        else return nMax;
    case SB_PAGELEFT:
        if (nValue > nMin)
            return nValue - 2;

    case SB_PAGERIGHT:
        if (nValue < nMax)
            return nValue + 2;

    case SB_LEFT:
        return nMin;

    case SB_RIGHT:
        return nMax;

    case SB_THUMBPOSITION:
    case SB_THUMBTRACK:
        return LOWORD(lParam);
    }

    return 0x7fff;
}

